HDU4849 Wow! Such City!(最短路,Djikstra)

2023-10-06 00:30
文章标签 短路 hdu4849 wow city djikstra

本文主要是介绍HDU4849 Wow! Such City!(最短路,Djikstra),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

题目:

Wow! Such City!

Time Limit: 15000/8000 MS (Java/Others)    Memory Limit: 102400/102400 K (Java/Others)
Total Submission(s): 1732    Accepted Submission(s): 581


Problem Description
Doge, tired of being a popular image on internet, is considering moving to another city for a new way of life.
In his country there are N (2 ≤N≤ 1000) cities labeled 0 . . . N - 1. He is currently in city 0. Meanwhile, for each pair of cities, there exists a road connecting them, costing C i, j (a positive integer) for traveling from city i to city j. Please note that C i, j may not equal to C j, i for any given i ≠ j.
Doge is carefully examining the cities: in fact he will divide cities (his current city 0 is  NOT included) into M (2 ≤ M ≤ 10 6) categories as follow: If the minimal cost from his current city (labeled 0) to the city i is Di, city i belongs to category numbered  Di mod M.Doge wants to know the “minimal” category (a category with minimal number) which contains at least one city.
For example, for a country with 4 cities (labeled 0 . . . 3, note that city 0 is not considered), Doge wants to divide them into 3 categories. Suppose category 0 contains no city, category 1 contains city 2 and 3, while category 2 contains city 1, Doge consider category 1 as the minimal one.
Could you please help Doge solve this problem?

Note:

C i, j is generated in the following way:
Given integers X 0, X 1, Y 0, Y 1, (1 ≤ X 0, X 1, Y 0, Y 1≤ 1234567), for k ≥ 2 we have
Xk  = (12345 + X k-1 * 23456 + X k-2 * 34567 + X k-1 * X k-2 * 45678)  mod  5837501
Yk  = (56789 + Y k-1 * 67890 + Y k-2 * 78901 + Y k-1 * Y k-2 * 89012)  mod  9860381
The for k ≥ 0 we have

Z k = (X k * 90123 + Y k ) mod 8475871 + 1

Finally for 0 ≤ i, j ≤ N - 1 we have

C i, j = Z i*n+j for i ≠ j
C i, j = 0   for i = j

Input
There are several test cases. Please process till EOF.
For each test case, there is only one line containing 6 integers N,M,X 0,X 1,Y 0,Y 1.See the description for more details.

Output
For each test case, output a single line containing a single integer: the number of minimal category.

Sample Input
  
3 10 1 2 3 4 4 20 2 3 4 5

Sample Output
  
1 10For the first test case, we have0 1 2 3 4 5 6 7 8 X 1 2 185180 788997 1483212 4659423 4123738 2178800 219267 Y 3 4 1633196 7845564 2071599 4562697 3523912 317737 1167849 Z 90127 180251 1620338 2064506 625135 5664774 5647950 8282552 4912390the cost matrix C is0 180251 16203382064506 0 56647745647950 8282552 0
Hint
So the minimal cost from city 0 to city 1 is 180251, while the distance to city 2 is 1620338. Given M = 10, city 1 and city 2 belong to category 1 and 8 respectively. Since only category 1 and 8 contain at least one city, the minimal one of them, category 1, is the desired answer to Doge’s question.

Source
2014西安全国邀请赛

Recommend
liuyiding   |   We have carefully selected several similar problems for you:   6018  6017  6016  6015  6014 
思路:

比赛的时候这个题没有看懂,因为好多数字,其实这题就是一个标准的迪杰斯特拉。

唯一的坑点在建图上面,必须按照题目要求的建图方式来建图,就是上面那一连串的式子。

只要建好图以后,找一下从0点到各个点的距离对m取模的最小值就是答案

还是太浮躁了,以后要注意

代码:

#include <stdio.h>
#include <string.h>
#include <string>
#include <iostream>
#include <stack>
#include <queue>
#include <vector>
#include <algorithm>
#define mem(a,b) memset(a,b,sizeof(a))
#define N 1000+20
#define inf 0x3f3f3f3f
#define M 1000000+2000
#define LL long long
using namespace std;
LL n,m,x00,x11,y00,y11;
LL map[N][N],dis[N],vis[N];
LL xx[M],yy[M],zz[M];
void init()//注意建图的方式,要按照题目的要求进行
{for(LL i=0; i<n; i++){for(LL j=0; j<n; j++){map[i][j]=inf;}map[i][i]=0;}xx[0]=x00;xx[1]=x11;yy[0]=y00;yy[1]=y11;for(LL k=2; k<=n*n; k++){xx[k]=(12345+xx[k-1]*23456+xx[k-2]*34567+xx[k-1]*xx[k-2]*45678)%5837501;yy[k]=(56789+yy[k-1]*67890+yy[k-2]*78901+yy[k-1]*yy[k-2]*89012)%9860381;}for(LL k=0; k<=n*n; k++){zz[k]=(xx[k]*90123+yy[k])%8475871+1;}for(LL i=0; i<n; i++){for(LL j=0; j<n; j++){if(i==j)map[i][j]=0;elsemap[i][j]=zz[i*n+j];}}
}
void dj()
{LL minn,k=0;for(LL i=0; i<=n; i++){dis[i]=map[0][i];vis[i]=0;}dis[0]=0;for(LL j=0; j<n; j++){minn=inf;for(LL i=0; i<n; i++){if(!vis[i]&&minn>dis[i]){minn=dis[i];k=i;}}vis[k]=1;for(LL i=0; i<n; i++){if(!vis[i]&&dis[i]>dis[k]+map[k][i])dis[i]=dis[k]+map[k][i];}}return;
}void solve()
{LL minn=inf;for(LL i=1; i<n; i++){minn=min(minn,dis[i]%m);}printf("%lld\n",minn);
}
int main()
{while(~scanf("%lld%lld%lld%lld%lld%lld",&n,&m,&x00,&x11,&y00,&y11)){init();//建图dj();//迪杰斯塔拉solve();//输出结果}return 0;
}


这篇关于HDU4849 Wow! Such City!(最短路,Djikstra)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/152391

相关文章

poj 1511 Invitation Cards(spfa最短路)

题意是给你点与点之间的距离,求来回到点1的最短路中的边权和。 因为边很大,不能用原来的dijkstra什么的,所以用spfa来做。并且注意要用long long int 来存储。 稍微改了一下学长的模板。 stack stl 实现代码: #include<stdio.h>#include<stack>using namespace std;const int M

poj 3259 uva 558 Wormholes(bellman最短路负权回路判断)

poj 3259: 题意:John的农场里n块地,m条路连接两块地,w个虫洞,虫洞是一条单向路,不但会把你传送到目的地,而且时间会倒退Ts。 任务是求你会不会在从某块地出发后又回来,看到了离开之前的自己。 判断树中是否存在负权回路就ok了。 bellman代码: #include<stdio.h>const int MaxN = 501;//农场数const int

poj 1502 MPI Maelstrom(单源最短路dijkstra)

题目真是长得头疼,好多生词,给跪。 没啥好说的,英语大水逼。 借助字典尝试翻译了一下,水逼直译求不喷 Description: BIT他们的超级计算机最近交货了。(定语秀了一堆词汇那就省略吧再见) Valentine McKee的研究顾问Jack Swigert,要她来测试一下这个系统。 Valentine告诉Swigert:“因为阿波罗是一个分布式共享内存的机器,所以它的内存访问

poj 3159 (spfa差分约束最短路) poj 1201

poj 3159: 题意: 每次给出b比a多不多于c个糖果,求n最多比1多多少个糖果。 解析: 差分约束。 这个博客讲差分约束讲的比较好: http://www.cnblogs.com/void/archive/2011/08/26/2153928.html 套个spfa。 代码: #include <iostream>#include <cstdio>#i

hdu 3790 (单源最短路dijkstra)

题意: 每条边都有长度d 和花费p,给你起点s 终点t,要求输出起点到终点的最短距离及其花费,如果最短距离有多条路线,则输出花费最少的。 解析: 考察对dijkstra的理解。 代码: #include <iostream>#include <cstdio>#include <cstdlib>#include <algorithm>#include <cstrin

poj 3255 次短路(第k短路) A* + spfa 或 dijkstra

题意: 给一张无向图,求从1到n的次短路。 解析: A* + spfa 或者 dijkstra。 详解见上一题:http://blog.csdn.net/u013508213/article/details/46400189 本题,spfa中,stack超时,queue的效率最高,priority_queue次之。 代码: #include <iostream>#i

poj 2449 第k短路 A* + spfa

poj 2449: 题意: 给一张有向图,求第k短路。 解析: A* + spfa。 一下转自:http://blog.csdn.net/mbxc816/article/details/7197228 “描述一下怎样用启发式搜索来解决K短路。 首先我们知道A*的基础公式:f(x)=g(x)+h(x);对h(x)进行设计,根据定义h(x)为当前的x点到目标点t所需要的实际距

poj 3259 最短路负环

John的农场里N块地,M条路连接两块地,W个虫洞,虫洞是一条单向路,会在你离开之前把你传送到目的地,就是当你过去的时候时间会倒退Ts。我们的任务是知道会不会在从某块地出发后又回来,看到了离开之前的自己。简化下,就是看图中有没有负权环。有的话就是可以,没有的话就是不可以了。 import java.io.BufferedReader;import java.io.InputStream;

POJ1724最短路

n个点,拥有总的价值money m条边(u,v,len ,cost),长度len,代价cost 求不超过money的代价条件下最短路。 public class Main {public static void main(String[] args) {new Task().solve();}}class Task {InputReader in = new InputReader

【AcWing】851. 求最短路

spfa算法其实是对贝尔曼福特算法做一个优化。 贝尔曼福特算法会遍历所有边来更新,但是每一次迭代的话我不一定每条边都会更新,SPFA是对这个做优化。 如果说dist[b]在当前这次迭代想变小的话,那么一定是dist[a]变小了,只有a变小了,a的后继(b)才会变小。 用宽搜来做优化,用一个队列,队列里边存的就是所有变小了的结点(队列里存的是待更新的点)。 基本思路就是我更新过谁,我再拿